unit OfficeEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TOfficeEdit = class(TCustomEdit)
  private
    { Private-Deklarationen}
    MouseIn : Boolean;
    PROCEDURE MouseEnter(VAR Message : TMessage); message CM_MOUSEENTER;
    PROCEDURE MouseLeave(VAR Message : TMessage); message CM_MOUSELEAVE;
    PROCEDURE DrawBorder;
    PROCEDURE SetFocus(VAR Message : TWMSetFocus); message WM_SETFOCUS;
    PROCEDURE KillFocus(VAR Message : TWMKillFocus); message WM_KILLFOCUS;
    PROCEDURE Paint(VAR Message : TMessage); message WM_PAINT;
  protected
    { Protected-Deklarationen}
  public
    { Public-Deklarationen}
    CONSTRUCTOR Create(AOwner : TComponent); override;
  published
    { Published-Deklarationen }
    property AutoSelect;
    property Anchors;
    property Align;
    property BiDiMode;
    property CharCase;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;

implementation

CONSTRUCTOR TOfficeEdit.Create(AOwner : TComponent);
BEGIN
 INHERITED;
 MouseIn := False;
 AutoSize := False;
 Ctl3D := False;
 Height := 21;
END;

PROCEDURE TOfficeEdit.DrawBorder;
VAR DC : HDC;
    R : TRect;
    BtnFaceColor, WindowColor, DarkFaceColor : HBRUSH;
BEGIN
 DC := GetWindowDC(Handle);
 TRY
  GetWindowRect(Handle, R);
  OffsetRect(R, -R.Left, -R.Top);
  BtnFaceColor := GetSysColorBrush(COLOR_BTNFACE);
  WindowColor := GetSysColorBrush(COLOR_WINDOW);
  DarkFaceColor := GetSysColorBrush(COLOR_BTNTEXT);
  IF Focused OR MouseIn THEN
   BEGIN
    DrawEdge (DC, R, BDR_SUNKENOUTER, BF_RECT or BF_ADJUST);
    FillRect(DC, Rect(R.Left,R.Top,R.Right-1,R.Top+1), DarkFaceColor);
    FillRect(DC, Rect(R.Left,R.Top,R.Left+1,R.Bottom-1), DarkFaceColor);
    DrawEdge(DC, R, BDR_SUNKENINNER, BF_BOTTOMRIGHT);
    InflateRect (R, -1, -1);
    FrameRect(DC, R, WindowColor);
   END
  ELSE
   BEGIN
    FrameRect (DC, R, BtnFaceColor);
    InflateRect (R, -1, -1);
    FrameRect (DC, R, BtnFaceColor);
    InflateRect (R, -1, -1);
    FrameRect (DC, R, WindowColor);
   END;
  FINALLY
    ReleaseDC (Handle, DC);
  END;
END;

PROCEDURE TOfficeEdit.MouseEnter(VAR Message : TMessage);
BEGIN
 INHERITED;
 MouseIn  := TRUE;
 DrawBorder;
END;

PROCEDURE TOfficeEdit.MouseLeave(VAR Message : TMessage);
BEGIN
 INHERITED;
 MouseIn  := FALSE;
 DrawBorder;
END;

PROCEDURE TOfficeEdit.SetFocus(VAR Message : TWMSetFocus);
BEGIN
 INHERITED;
 DrawBorder;
END;

procedure TOfficeEdit.KillFocus (var Message: TWMKillFocus);
BEGIN
 INHERITED;
 DrawBorder;
END;

PROCEDURE TOfficeEdit.Paint(VAR Message : TMessage);
BEGIN
 INHERITED;
 DrawBorder;
END;

procedure Register;
begin
  RegisterComponents('Freeware', [TOfficeEdit]);
end;

end.
